-- a little shortcut.
local IsValid = function(mo)
	return (mo and mo.valid)
end

--Assign numbers to each emblem on load.
addHook("MapLoad", function()
	for mt in mapthings.iterate do
		if mt.type == mobjinfo[MT_EMBLEM].doomednum
			local ghs = P_SpawnMobj(mt.x*FRACUNIT, mt.y*FRACUNIT, 0, MT_SMSTARCOIN)
			if mt.angle != nil
				ghs.smstarcoin = mt.angle+1 
			else
				ghs.smstarcoin = 10
			end
			ghs.smstarcoinztime = 2
			ghs.smstarcoinz = mt.z
			ghs.scale = 110000
			ghs.smstarcoinangle = 0
		end
	end
end)

--The emblem itself
addHook("MobjThinker", function(s)
	if s.valid and s.smstarcoin and (s.smstarcoin != nil)
	
		if s.smstarcoinztime
			s.smstarcoinztime = $-1
			
			--After 2 tics, move yourself up to your correct Z location and become collectible.
			if not s.smstarcoinztime
				if s.smstarcoinz != nil
				s.flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_SPECIAL
				s.z = s.floorz+(s.smstarcoinz*FRACUNIT)
				s.spriteyoffset = 19*FRACUNIT
				s.smstarcoinz = nil
				end
			end
		end
		
		--speen
		if not s.health
			if not s.fuse
				s.fuse = 25
			elseif s.fuse < 16
				s.frame = A|FF_PAPERSPRITE|TR_TRANS80-((s.fuse*FRACUNIT)/4)
			end
			s.smstarcoinangle = $+ANGLE_45
			s.angle = s.smstarcoinangle
		else
			s.smstarcoinangle = $+ANG10
			s.angle = s.smstarcoinangle
		end	
	end
end, MT_SMSTARCOIN)

--Hide yourself, they can't know we're secretly still here.
addHook("MobjThinker", function(s)
	if s.valid
		s.flags = $|MF2_DONTDRAW
	end
end, MT_EMBLEM)

--Broadcast serverwide message. You got one, you absolute chad!

addHook("TouchSpecial", function(emblem, s)
	if IsValid(emblem) and emblem.health
	and IsValid(s) and s.player
		if (emblem.eflags & MFE_UNDERWATER) then
			P_SetObjectMomZ(emblem, 3*FRACUNIT)
		else
			P_SetObjectMomZ(emblem, 6*FRACUNIT)
		end
		
		P_AddPlayerScore(s.player, 4000)
		if emblem.smstarcoin then
			print("\x80" .. s.player.name .. " GOT A STAR COIN !\x87 " .. emblem.smstarcoin)
		end
		
		emblem.health = 0
		emblem.state = S_SMSTARCOINGET
		emblem.fuse = 25
		emblem.flags = $ & ~(MF_NOGRAVITY)
		S_StartSound(s, sfx_scsfxz)
		
		-- spawn the sparkle
		local sparkle = P_SpawnMobj(emblem.x, emblem.y, emblem.z, MT_THOK)
		sparkle.scale = $ / 2
		sparkle.target = emblem
		sparkle.state = S_SMSCSHNE
	end
	return true
end, MT_SMSTARCOIN)